unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, process;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button3: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Memo1: TMemo;
    Memo2: TMemo;
    Timer1: TTimer;
    Timer2: TTimer;
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
  private
    { private declarations }
  public
  end;

var
  Form1: TForm1;
  p:tprocess;
  pfad,profilfile:string;
implementation

{$R *.lfm}

{ TForm1 }

// Versuch mit Kommando-Übergabe
procedure TForm1.Button3Click(Sender: TObject);
var s:string;
begin
 profilfile:=edit2.text;
 if pos('.',profilfile) >0
  then
   profilfile:=copy(profilfile,1,pos('.',profilfile)-1);

 memo1.Clear;
 memo2.Clear;
 deletefile(profilfile+'.pol');
 timer1.Enabled:=true;

 P.Options := [poUsePipes,poNoConsole];
 p.PipeBufferSize:=32768;
 p.Executable:=pfad+'\xfoil.exe';
 p.Execute;

 // Ab hier die Kommandos
 s:='load '+profilfile+'.DAT'+#13#10;
 p.Input.Write(s[1],length(s));
 s:='pane'+#13#10;
 p.Input.Write(s[1],length(s));
 s:='oper'+#13#10;
 p.Input.Write(s[1],length(s));
 s:='visc 65000'+#13#10;
 p.Input.Write(s[1],length(s));

 s:='iter'+#13#10;
 p.Input.Write(s[1],length(s));
 s:='50'+#13#10;
 p.Input.Write(s[1],length(s));
 s:='pacc'+#13#10;
 p.Input.Write(s[1],length(s));
 s:=profilfile+'.pol'+#13#10;
 p.Input.Write(s[1],length(s));
 s:=#13#10;
 p.Input.Write(s[1],length(s));

 // Anstellwinkel-Sequenz
 s:='aseq 0 20 0.25'+#13#10;
 p.Input.Write(s[1],length(s));
 s:='init'+#13#10;
 p.Input.Write(s[1],length(s));
 s:='aseq 0.25 -20 0.25'+#13#10;
 p.Input.Write(s[1],length(s));

 // Auftriebsbeiwert-Sequenz
(* s:='cseq 0 4 0.05'+#13#10;
 p.Input.Write(s[1],length(s));
 s:='init'+#13#10;
 p.Input.Write(s[1],length(s));
 s:='cseq 0 -4 0.05'+#13#10;
 p.Input.Write(s[1],length(s));*)

 s:='pacc'+#13#10;
 p.Input.Write(s[1],length(s));

 s:=#13#10;
 p.Input.Write(s[1],length(s));
 s:='quit'+#13#10;
 p.Input.Write(s[1],length(s));
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  NoMoreOutput: boolean;
  s:string;

  procedure DoStuffForProcess(Process: TProcess; StartButton: TButton;
    OutputMemo: TMemo);
  var
    Buffer: string;
    BytesAvailable: DWord;
    BytesRead:LongInt;
  begin
   StartButton.Enabled := not Process.Running;
   if Process.Running then
   begin
     BytesAvailable := Process.Output.NumBytesAvailable;
     BytesRead := 0;
     while BytesAvailable>0 do
     begin
       SetLength(Buffer, BytesAvailable);
       BytesRead := Process.OutPut.Read(Buffer[1], BytesAvailable);
       OutputMemo.Text := OutputMemo.Text + copy(Buffer,1, BytesRead);
       BytesAvailable := Process.Output.NumBytesAvailable;
       NoMoreOutput := false;
       OutputMemo.Update;
       OutputMemo.SelStart := Length(OutputMemo.Text);
       edit1.text:=inttostr(filesize(profilfile+'.pol'));
       edit1.update;
     end;
   end;
  end;

begin
 repeat
   NoMoreOutput := true;
   DoStuffForProcess(P, button3, memo1);
 until noMoreOutput;

 if not P.Running
  then
   begin
    s:=memo1.Lines[memo1.Lines.Count-1];
    s:=trimleft(s);
    s:=trimright(s);
    if s='XFOIL   c>'
     then
      begin
       memo2.Lines.LoadFromFile(profilfile+'.pol');
       timer1.Enabled:=false;
      end;
   end;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
 if p=nil then exit;
 edit3.text:=inttostr(p.ExitStatus);
 edit3.Update;
end;

// Aktuellen Pfad holen
procedure TForm1.FormCreate(Sender: TObject);
begin
 pfad:=extractfiledir(paramstr(0));
 p:=tprocess.Create(nil);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 freeandnil(p);
end;


end.

